%
%  PCC Sample Script -- Fix Towees
%
%  To try this function:
%  + load the script, by using [Alt-R] on the race screen, or
%    `Load "fixtow.q"' on the console
%  + type `FixTowees' at the console. This will set all ships which are
%    being towed to Warp 0, so they won't accidentially break the tow.
%
%  Alternatively, do `cc GAME PLAYER /rk Load "fixtow.q"'
%
Sub FixTowees
  % note that this could also be put in one line
  ForEach Ship
    If Mission$=7 Then
      Try With Ships(Mission.Tow) Do SetSpeed 0
    EndIf
  Next
EndSub

% The following "trick" allows easy use of this script from the
% command line: the only case where we are not in GUI mode but
% have a race loaded is when player does `cc /rk Load "..."'.
If Not System.GUI And My.Race Then
  Print "Setting towees to Warp 0..."
  FixTowees
EndIf
