%
%  Scramble Ships Names Off, restore the original names
%
%  Author  : Manuel Fernandes Alonso
%  Version : 1.0.1
%  Date    : 28/09/2001  (DD/MM/YYYY)
%  History : 1.0 Initial version
%            1.1 The program verifies if the ship is own, to avoid restore captured or destroyed ships
%
%  Run this after unpack the trn and prior other utilities
%

Dim MFALinea    := ""
Dim MFAShipID   := 0
Dim MFAShipName := ""

Local fd := FreeFile()

Open System.GameDirectory & "SName" & My.Race$ & ".TXT" for input as fd

Do
   Input #fd, MFALineA, 1
   If IsEmpty(MFALineA) Then Break
   
      MFAShipID   := VAL(Left(MFALinea, 3))
      MFAShipName := Mid(MFALinea, 4)
      If Ships(MFAShipID).Owner$ = My.Race$ Then Ships(MFAShipID).Name := MFAShipName
Loop

Close fd

MessageBox "Program Terminated"
